
;=============;
; Goal Tape   ;
;=============;

;Normal bit = normal exit goal.
;Extra bit set = secret exit.

;==========
;Configurables
;==========

!Sfx = $09			; Sound. Bank = $1DFB of course.
!Tile = $D4			; Tile to draw.
!Timer = $7C			; Duration timer until it goes back down and vice versa.
!Music = $0C			; Goal tape music.
!BonusTimer = $40		; Amount of time to draw bonus stars number.

DATA_01C0A5: db $10,$F0		; Maximum height, up/down.

;=============

print "INIT ",pc
	LDA $E4,x	;\
	SEC		; | Sprite X position - #$08
	SBC #$08	; | = Sprite state.
	STA $C2,x	;/
	LDA $14E0,x	;\
	SBC #$00	; | Store X high into $151C?
	STA $151C,x	;/
	LDA $D8,x	;\
	STA $1528,x	;/ Preserve Y position into $1528,x.
	LDA $14D4,x	;\
	;STA $187B,x	;/ Uncommented, because I use extra bit for goal type.
	AND #$01	;\
	STA $14D4,x	; | I think these are preserved to check if Mario touches the sprite in the same X range.
	STA $1534,x	;/
	RTL

print "MAIN ",pc
	PHB		;\
	PHK		; | Make data bank running from here.
	PLB		; | Call local subroutine.
	JSR Spr		; |
	PLB		; | Restore it when we're done.
	RTL		;/

;=========
;Main
;=========           
Spr:
	JSR SprGfx		; Branch to draw tilemaps of sprite.
	LDA $9D			;\
	BNE Locked		;/ If locked, return.
	LDA $1602,x		;\ If goal already touched, return.
	BEQ Code0A7		;/ (#$01).
Locked: RTS


Code0A7:
CODE_01C0A7:                      LDA.w $1540,X 	;\ If timer duration is set, don't set again.           
CODE_01C0AA:                      BNE CODE_01C0B4       ;/ (Obviously..)
CODE_01C0AC:                      LDA.b #!Timer 	;\              
CODE_01C0AE:                      STA.w $1540,X         ;/ Set timer for Y movement.  
CODE_01C0B1:                      INC.w $1588,X 	; Increase object status?? 
CODE_01C0B4:                      LDA.w $1588,X  	;\
CODE_01C0B7:                      AND.b #$01            ; |  
CODE_01C0B9:                      TAY                   ; | Get two bits (0,1) of it. 
CODE_01C0BA:                      LDA.w DATA_01C0A5,Y   ; |      
CODE_01C0BD:                      STA $AA,X    		;/ Use it to store up/down movement to Y speed.
CODE_01C0BF:                      JSL $01801A		; Update Y Pos, no gravity.   
CODE_01C0C2:                      LDA $C2,X 		;\    
CODE_01C0C4:                      STA $00               ;/ Preserve $C2,x to $00.  
CODE_01C0C6:                      LDA.w $151C,X		;\ Store sprite X position high into $01.       
CODE_01C0C9:                      STA $01               ;/
CODE_01C0CB:                      REP #$20              ; Accum (16 bit) 
CODE_01C0CD:                      LDA $94		;\         
CODE_01C0CF:                      SEC			; | Subtract $00 from Mario's X position.                      
CODE_01C0D0:                      SBC $00               ; |    
CODE_01C0D2:                      CMP.w #$0010 		; | If it's over 10 ..            
CODE_01C0D5:                      SEP #$20		; | I think it could be the X range to end the goal.
CODE_01C0D7:                      BCS Return01C12C      ;/  
CODE_01C0D9:                      LDA.w $1528,X 	;\           
CODE_01C0DC:                      CMP $96         	; |
CODE_01C0DE:                      LDA.w $1534,X		; |            
CODE_01C0E1:                      AND.b #$01            ; | If Mario is not in the vertical range of sprite, return.
CODE_01C0E3:                      SBC $97       	; |
CODE_01C0E5:                      BCC Return01C12C      ;/   
CODE_01C0E7:                     ; LDA.w $187B,X             ; \ $141C = #01 if Goal Tape triggers secret exit 
CODE_01C0EA:                     ; LSR                       ;  | 
CODE_01C0EB:                     ; LSR                       ;  | 
CODE_01C0EC:                     ; STA.w $141C               ; / 

LDA $7FAB10,x		;\
AND #$04		; |
BEQ +			; | Branch if extra bit clear.
INC $141C		; | Otherwise, $141C = 01 (set secret goal flag).
+			; | I think this is why doesn't work in vertical levels.
			;/ $141C is ignored in vertical levels.
			; Too lazy to fix it though.
			; However, you can try LDA #$FF : STA $0DD5.
			; ..wait, I'm entirely wrong.
			; Nothing shows up on a vertical level!
			; Maybe the routine overall is crap?

CODE_01C0EF:                      LDA.b #!Music		; Play goal music.              
CODE_01C0F1:                      STA.w $1DFB
CODE_01C0F4:                      LDA.b #$FF    	;\            
CODE_01C0F6:                      STA.w $0DDA           ;/ Still have no idea what this does. Maybe it preserves old music?  
CODE_01C0F9:                      ;LDA.b #$FF  		; It's already loaded!              
CODE_01C0FB:                      STA.w $1493 		; Set goal timer to FF.              
CODE_01C0FE:                      STZ.w $1490		; Clear star timer.
CODE_01C101:                      INC.w $1602,X 	; Indicate that goal is on?            
CODE_01C104:                      JSL $01A7DC   	;\         
CODE_01C107:                      BCC CODE_01C125       ;/ If Mario touches sprite ..  
CODE_01C109:                      LDA.b #!Sfx		; .. execute all this code.
CODE_01C10B:                      STA.w $1DFC		; Play sound.
CODE_01C10E:                      INC.w $160E,X		; This one is used as a flag to not draw the tape Gfx I believe.           
CODE_01C111:                      LDA.w $1528,X		;\ 	            
CODE_01C114:                      SEC                   ; | Subtract current Y position from initial one..  
CODE_01C115:                      SBC $D8,X       	; | And store into $1594,x. Probably used by below routine.
CODE_01C117:                      STA.w $1594,X         ;/    
CODE_01C11A:                      LDA.b #!BonusTimer	;\ Duration to draw bonus star #.             
CODE_01C11C:                      STA.w $1540,X         ;/     
CODE_01C11F:                      JSL.l $07F252
CODE_01C123:                      BRA CODE_01C128           

CODE_01C125:			  STZ $1686,x 		; Clear all tweaker bits.
CODE_01C128:			  JSL $00FA80 		; Trigger goal tape routine.
Return01C12C:			  RTS	
;====================

SprGfx:
CODE_01C12D:                      LDA.w $160E,X  	;\           
CODE_01C130:                      BNE CODE_01C175       ;/ If the goal tape has been touched, skip Gfx routine.  
CODE_01C132:                      JSR.w GET_DRAW_INFO    
CODE_01C135:                      LDA $00   		;\                
CODE_01C137:                      SEC                   ; | Apply X displacement.  
CODE_01C138:                      SBC.b #$08            ; | 
CODE_01C13A:                      STA.w $0300,Y         ;/
CODE_01C13D:                      CLC         		;\              
CODE_01C13E:                      ADC.b #$08            ; | 
CODE_01C140:                      STA.w $0304,Y    	;/ OAM Tile (X) #2
CODE_01C143:                      CLC      		;\                 
CODE_01C144:                      ADC.b #$08            ; |  
CODE_01C146:                      STA.w $0308,Y    	;/ OAM tile (X) #3.
CODE_01C149:                      LDA $01  		;\ Get Y pos ..                 
CODE_01C14B:                      CLC                   ; |
CODE_01C14C:                      ADC.b #$08            ; | 
CODE_01C14E:                      STA.w $0301,Y         ;/ Apply displacement and store.
CODE_01C151:                      STA.w $0305,Y         ;\ There isn't any other tile to displace, so directly store.
CODE_01C154:                      STA.w $0309,Y 	;/   
CODE_01C157:                      LDA.b #!Tile          ;\ Tile of sprite.  
CODE_01C159:                      STA.w $0302,Y  	;/ Is stored to OAM tile.        
CODE_01C15C:                      INC A			;\                     
CODE_01C15D:                      STA.w $0306,Y        	;/ The next ones are stored to the next OAM tiles.
CODE_01C160:                      STA.w $030A,Y     	;\    
CODE_01C163:                      LDA.b #$32            ;\  
CODE_01C165:                      STA.w $0303,Y         ; | Property byte for all tiles.
CODE_01C168:                      STA.w $0307,Y         ; |
CODE_01C16B:                      STA.w $030B,Y     	;/
CODE_01C16E:                      LDY.b #$00    	;\ We drew 8x8 tiles, so 00 instead of the normal 02.           
CODE_01C170:                      LDA.b #$02            ;/ # of tiles drawn = 3.
CODE_01C172:                      JSL $01B7B3		; Finish OAM write.
				  RTS 			;JMP.W FinishOAMWriteRt    

CODE_01C175:                      LDA.w $1540,X		    ;\   If bonus star number timer duration is over ..           
CODE_01C178:                      BEQ CODE_01C17F 	    ;/   Clear sprite.        
CODE_01C17A:                      JSL.l $07F1CA 	    ; This routine draws bonus star numbers after hitting the goal tape. Uncomment if you don't want any.         
Return01C17E:                     RTS                       ; Return 

CODE_01C17F:                      STZ.w $14C8,X   	    ; Erase sprite.          
Return01C182:                     RTS                       ; Return 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817        

SUB_HORZ_POS:        LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16:             RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642
                    



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;       Y = index to sprite OAM ($300)
;       $00 = sprite x position relative to screen boarder
;       $01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1:              db $0C,$1C
SPR_T2:             db $01,$02

GET_DRAW_INFO:       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X:         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC #$0040            ;  |
                    CMP #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP:      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y:         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID:             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_OFF_SCREEN
; This subroutine deals with sprites that have moved off screen
; It is adapted from the subroutine at $01AC0D
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
SPR_T12:             db $40,$B0
SPR_T13:             db $01,$FF
SPR_T14:             db $30,$C0,$A0,$C0,$A0,$F0,$60,$90		;bank 1 sizes
		            db $30,$C0,$A0,$80,$A0,$40,$60,$B0		;bank 3 sizes
SPR_T15:             db $01,$FF,$01,$FF,$01,$FF,$01,$FF		;bank 1 sizes
					db $01,$FF,$01,$FF,$01,$00,$01,$FF		;bank 3 sizes

SUB_OFF_SCREEN_X1:   LDA #$02                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ;  | (table entry to use on horizontal levels)
SUB_OFF_SCREEN_X2:   LDA #$04                ;  | 
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X3:   LDA #$06                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X4:   LDA #$08                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X5:   LDA #$0A                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X6:   LDA #$0C                ;  |
                    BRA STORE_03            ;  | OMG YOU FOUND THIS HIDDEN z0mg place!111 you win a cookie!
SUB_OFF_SCREEN_X7:   LDA #$0E                ;  |
STORE_03:			STA $03					;  |            
					BRA START_SUB			;  |
SUB_OFF_SCREEN_X0:   STZ $03					; /

START_SUB:           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_35           ; /
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ; |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ; | 
                    ADC #$50                ; | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ; | 
                    CMP #$02                ; | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0756 VC:176 00 FL:205
                    AND #$01                ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0780 VC:176 00 FL:205
                    ORA $03                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0796 VC:176 00 FL:205
                    STA $01                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0820 VC:176 00 FL:205
                    TAY                     ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0844 VC:176 00 FL:205
                    LDA $1A                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0858 VC:176 00 FL:205
                    CLC                     ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0882 VC:176 00 FL:205
                    ADC SPR_T14,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0896 VC:176 00 FL:205
                    ROL $00                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizcHC:0928 VC:176 00 FL:205
                    CMP $E4,x               ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:0966 VC:176 00 FL:205
                    PHP                     ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:0996 VC:176 00 FL:205
                    LDA $1B                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizCHC:1018 VC:176 00 FL:205
                    LSR $00                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdiZCHC:1042 VC:176 00 FL:205
                    ADC SPR_T15,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizcHC:1080 VC:176 00 FL:205
                    PLP                     ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F0 P:eNvMXdizcHC:1112 VC:176 00 FL:205
                    SBC $14E0,x             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1140 VC:176 00 FL:205
                    STA $00                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1172 VC:176 00 FL:205
                    LSR $01                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1196 VC:176 00 FL:205
                    BCC SPR_L31             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1234 VC:176 00 FL:205
                    EOR #$80                ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1250 VC:176 00 FL:205
                    STA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1266 VC:176 00 FL:205
SPR_L31:             LDA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1290 VC:176 00 FL:205
                    BPL RETURN_35           ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1314 VC:176 00 FL:205
ERASE_SPRITE:        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ; |
                    BCC KILL_SPRITE         ; /    
                    LDY $161A,x             ;A:FF08 X:0007 Y:0001 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1108 VC:059 00 FL:2878
                    CPY #$FF                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1140 VC:059 00 FL:2878
                    BEQ KILL_SPRITE         ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1156 VC:059 00 FL:2878
                    LDA #$00                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1172 VC:059 00 FL:2878
                    STA $1938,y             ;A:FF00 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZcHC:1188 VC:059 00 FL:2878
KILL_SPRITE:         STZ $14C8,x             ; erase sprite
RETURN_35:           RTS                     ; return

VERTICAL_LEVEL:      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ; \
                    LSR A                   ; | 
                    BCS RETURN_35           ; /
                    LDA $E4,x               ; \ 
                    CMP #$00                ;  | if the sprite has gone off the side of the level...
                    LDA $14E0,x             ;  |
                    SBC #$00                ;  |
                    CMP #$02                ;  |
                    BCS ERASE_SPRITE        ; /  ...erase the sprite
                    LDA $13                 ;A:0000 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:1218 VC:250 00 FL:5379
                    LSR A                   ;A:0016 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1242 VC:250 00 FL:5379
                    AND #$01                ;A:000B X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1256 VC:250 00 FL:5379
                    STA $01                 ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1272 VC:250 00 FL:5379
                    TAY                     ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1296 VC:250 00 FL:5379
                    LDA $1C                 ;A:001A X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0052 VC:251 00 FL:5379
                    CLC                     ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0076 VC:251 00 FL:5379
                    ADC SPR_T12,y           ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0090 VC:251 00 FL:5379
                    ROL $00                 ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:enVMXdizCHC:0122 VC:251 00 FL:5379
                    CMP $D8,x               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0160 VC:251 00 FL:5379
                    PHP                     ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0190 VC:251 00 FL:5379
                    LDA $001D             ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F2 P:eNVMXdizcHC:0212 VC:251 00 FL:5379
                    LSR $00                 ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdiZcHC:0244 VC:251 00 FL:5379
                    ADC SPR_T13,y           ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdizCHC:0282 VC:251 00 FL:5379
                    PLP                     ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:envMXdiZCHC:0314 VC:251 00 FL:5379
                    SBC $14D4,x             ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0342 VC:251 00 FL:5379
                    STA $00                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0374 VC:251 00 FL:5379
                    LDY $01                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0398 VC:251 00 FL:5379
                    BEQ SPR_L38             ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0422 VC:251 00 FL:5379
                    EOR #$80                ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0438 VC:251 00 FL:5379
                    STA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0454 VC:251 00 FL:5379
SPR_L38:             LDA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0478 VC:251 00 FL:5379
                    BPL RETURN_35           ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0502 VC:251 00 FL:5379
                    BMI ERASE_SPRITE        ;A:8AFF X:0002 Y:0000 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0704 VC:184 00 FL:5490

SUB_IS_OFF_SCREEN:   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ; |  
                    RTS                     ; / re